#!/usr/bin/python3

import subprocess
import re
import time
import os

def wakeupTime(time):
  #print("WakeupTime: ", time)
  subprocess.run("/usr/sbin/rtcwake -m no -t %s"%(time), shell=True)
  return True

# vdr next Timer, is recording
def vdr():
  # vdr command to get next timer, covert to string and split by space
  vdr_output=subprocess.check_output('/usr/bin/svdrpsend NEXT abs', shell=True)
  vdr_string = vdr_output.decode("utf-8")
  vdr_split =re.findall(r'\S+', vdr_string)
  #print("Ausgabe svdrpsend: ", vdr_output)

  # search for next timer time
  vdr_num = 0
  vdr_timer = 0
  for x in vdr_split:
    if x =="250":  #active timer
      vdr_timer = vdr_split[vdr_num+2]
    elif x =="550": #no active timer
      vdr_timer = 0
    vdr_num += 1

  # search for current record
  currentTime = int(time.time())
  vdr_record = currentTime - int(vdr_timer)
  #print("Errechnerter Wert: ", vdr_record)
  if vdr_record == currentTime:
    print("Keine Aufnahme geplant")
    return False
  elif vdr_record < -600:
    print("Aufnahme in der Zukunft: ", vdr_timer)
    timer = int(vdr_timer)
    wakeupTime(timer)
    return False
  elif vdr_record >= -600:
    print("Aufnahme läuft aktuell bzw. beginnt in den nächsten 10min")
    return True
  else:
    print("")
    return True

def ssh():
  try: 
    sOut=subprocess.check_output('/bin/netstat --tcp --numeric | grep --count ":22"', shell=True)
    active = (int(sOut.decode()) > 0)
    print("SSH Verbindung aktiv")
    if active:
      return True
  except subprocess.CalledProcessError as e:
     print("SSH Verbindung inaktiv")
  return False

def programActive(name):
  try: 
    sOut=subprocess.check_output('/usr/bin/pgrep %s'%(name), shell=True)
    active = (nlcount(sOut) > 0)
    print("Folgendes Programm ist aktiv", name)
    if active:
      return True
  except subprocess.CalledProcessError as e:
    print("Folgendes Programm ist inaktiv: ", name)
    return False

def backupActive():
  devnull = open(os.devnull, 'w')
  subprocess.run('/usr/bin/duc login http://glotze:8200', shell=True, stdout=devnull, stderr=devnull)
  sOut=subprocess.check_output('/usr/bin/duc status', shell=True)
  x = sOut.decode('UTF-8','strict')
  #print(x)
  # Running status = "Backup_Begin on backup 4", "Backup_ProcessingFiles on backup 4", 
  # Not Running status = Idle
  if x.find("backup 4") >= True:
    print("Backupprozess ist aktiv")
    subprocess.run('/usr/bin/duc logout', shell=True, stdout=devnull, stderr=devnull)
    return True
  else:
    print("Backupprozess ist inaktiv")
    subprocess.run('/usr/bin/duc logout', shell=True, stdout=devnull, stderr=devnull)
    return False

#Helper
def nlcount(buf):
  nl_count = 0  # Number of new line characters
  tot_count = 0  # Total number of characters
  for character in buf.decode():
    if character == '\n':
      nl_count += 1
    tot_count += 1
  return nl_count


# main program

#conditions
shutdown = False
shutdown += vdr()
shutdown += ssh()
shutdown += programActive("kodi")
shutdown += programActive("firefox")
shutdown += programActive("chrome")
shutdown += programActive("vlc")
shutdown += backupActive()

# result
if shutdown == False:
  print("System wird runtergefahren")
  subprocess.run("/sbin/shutdown -h now", shell=True)
else:
  print("System wird NICHT runtergefahren")

